"use strict";
// TODO: optional init function support
// TODO: class-validators support
Object.defineProperty(exports, "__esModule", { value: true });
const proxy_1 = require("./proxy");
const settings_1 = require("./settings");
const util_1 = require("./util");
function Mixin(...constructors) {
    const prototypes = constructors.map(constructor => constructor.prototype);
    function MixedClass(...args) {
        for (const constructor of constructors)
            util_1.copyProps(this, new constructor(...args));
    }
    MixedClass.prototype = settings_1.settings.prototypeStrategy === 'copy'
        ? util_1.hardMixProtos(prototypes, MixedClass)
        : util_1.softMixProtos(prototypes, MixedClass);
    Object.setPrototypeOf(MixedClass, settings_1.settings.staticsStrategy === 'copy'
        ? util_1.hardMixProtos(constructors, null, ['prototype'])
        : proxy_1.proxyMix(constructors, Function.prototype));
    return MixedClass;
}
exports.Mixin = Mixin;
/**
 * A decorator version of the `Mixin` function.  You'll want to use this instead of `Mixin` for mixing generic classes.
 */
const mix = (...ingredients) => 
// @ts-ignore
decoratedClass => Mixin(...(ingredients.concat([decoratedClass])));
exports.mix = mix;
